<template>
    <div class="q-gutter-y-md">
        <div class="text-h5 text-weight-light"> {{ title }}</div>
        <ErrorBanner :errors="bannerErrors"/>
        <FormCore
            :errors="errors"
            :has-error="hasError"
            :value="value"
            :fields="fields"
            @input="OnInput"
        >
            <template v-for="s in Slots" #[s]>
                <slot :name="s"/>
            </template>

        </FormCore>
        <slot/>
        <q-btn color="primary" :disable="!value.valid" label="submit" @click="Submit" :loading="loading"/>

    </div>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import ErrorBanner from "components/ErrorBanner.vue";
import {BasicFormModel, FormElement} from "src/classLibrary/FormTypes";
import {ApiError} from "src/classLibrary/Core/Api";
import {$$, ApplyValidation} from "src/classLibrary/Utility";
import FormCore from "components/FormCore.vue";
import {Result} from "@hqoss/monads";

@Component({
    components: {FormCore, ErrorBanner}
})
export default class Form extends Vue {
    @Prop() title!: string;
    @Prop() value!: BasicFormModel
    @Prop() fields!: FormElement[]
    @Prop() onSubmit!: (models: BasicFormModel) => Promise<Result<any, ApiError>>;

    bannerErrors: string[] = [];
    errors: { [s: string]: string | null } = {}
    hasError: { [s: string]: boolean } = {}

    created() {
        this.fields.Each(e => {
            this.errors[e.key] = '';
            this.hasError[e.key] = false;
        })
    }

    loading: boolean = false;

    get Slots() {
        return this.fields.Map(x => [x.key + 'Append', x.key + 'Prepend']).Flatten<string>();

    }

    async Submit() {


        const parent = this;
        if (!this.value.valid) return;

        this.loading = true;
        const r = await this.onSubmit(this.value);

        let errs: string[] = [];
        r.match({
            ok: (a) => {
                this.$emit("success", a);
            },
            err: e => ApiError.match(e, {

                Object: (o) => {
                    errs = ApplyValidation(parent.errors, parent.hasError, o)
                },
                String: (o) => {
                    errs = [o.error]
                },
                Null: (o) => {
                    if (o?.error) {
                        const e: string = o.error;
                        errs = [e]
                    }
                },
                Unknown: (u) => {
                    this.$emit('unknown', ApiError.Unknown(u))
                },
                Auth: (a) => {
                    this.$emit('auth', ApiError.Auth(a))
                }
            })
        })
        await $$(1000);
        this.bannerErrors = errs;
        this.loading = false;
    }

    OnInput(e: BasicFormModel) {
        for (let k in this.hasError) {
            this.hasError[k] = false
        }
        for (let k in this.errors) {
            this.errors[k] = ''
        }
        this.bannerErrors = [];
        this.$emit('input', e)
    }

}
</script>
